<?php
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * 					____________________						   *
 * 					 	WAmailer 1.3							   *
 * 											   *
 * 		Fichier 	:		mailer.php							   *
 * 		Cr le 	:		29 juin 2002						   *
 * 		Dernire modif :	10 septembre 2002 					   *
 * 		Email		: 		wascripts@phpcodeur.net				   *
 * 		Version		:		1.3									   *
 * 			 Copyright 2002 PHPcodeur							   *
 * 							  									   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 *																   *
 *  This program is free software; you can redistribute it and/or  *
 * 	modify it under the terms of the GNU General Public License as *
 * 	published by the Free Software Foundation; either version 2 of *
 *  the License, or (at your option) any later version.			   *
 * 																   *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */


/*
 *  Classe d'envoi des emails.
 *  Fonctionne aussi chez online et nexen
 *  Gre l'attachement de pices jointes et l'envoi d'emails au format html
 *
 */


class Mailer {

	// chemin par dfaut pour les modles d'emails
	var $root = '';
	
	// vous devez dfinir la fonction mail qu'utilise votre hbergeur
	//
	// 
	// 1 pour la fonction mail() classique
	// 2 pour la fonction email() de online
	// 3 pour la fonction email() de nexen
	//
	var $hebergeur = 1; 
	
	// ou bien, vous pouvez utiliser un smtp en fournisant les donnes ncessaires ici
	//
	// $smtp_mode 
	// Mettez  true si vous voulez utiliser un serveur smtp
	//
	// Remplissez le tableau pour indiquer au script les donnes qui lui permettront de se 
	// connecter au serveur.
	//
	// host -> nom ou ip du serveur smtp (ex: smtp.wanadoo.fr)
	// port -> port utilis (en gnral 25)
	// user -> login pour la connexion (seulement si ncessaire)
	// pass -> password pour la connexion (seulement si ncessaire)
	
	var $smtp_mode = false;
	
	var $smtp = array(
			'host' => '', 
			'port' => 25, 
			'user' => '', 
			'pass' => '' 
		);
	//
	// Tableau des extensions et de leur Mime-Type
	// Rien ne vous interdit d'en rajouter si besoin est.
	//
	var $mime_type = array(
			'txt'  => 'text/plain', 
			'rtx'  => 'text/richtext', 
			'html' => 'text/html', 
			'htm'  => 'text/html', 
			'xml'  => 'text/xml', 
			'xls'  => 'text/xml', 
			'tsv'  => 'text/tab-separated-value', 
			'etx'  => 'text/x-setext', 
			
			'eml'  => 'message/rfc822', 
			'nws'  => 'message/rfc822', 

			'bmp'  => 'image/bmp', 
			'pcx'  => 'image/bmp', 
			'gif'  => 'image/gif', 
			'ief'  => 'image/ief', 
			'jpeg' => 'image/jpeg', 
			'jpg'  => 'image/jpeg', 
			'jpe'  => 'image/jpeg', 
			'png'  => 'image/png', 
			'tiff' => 'image/tiff', 
			'tif'  => 'image/tiff', 
			'cmu'  => 'image/x-cmu-raster', 
			'pnm'  => 'image/x-portable-anymap', 
			'pbm'  => 'image/x-portable-bitmap', 
			'pgm'  => 'image/x-portable-graymap', 
			'ppm'  => 'image/x-portable-pixmap', 
			'rgb'  => 'image/x-rgb', 
			'xbm'  => 'image/x-xbitmap', 
			'xpm'  => 'image/x-xpixmap', 
			'xwd'  => 'image/x-xwindowdump', 

			'dwg'  => 'application/acad', 
			'ccad' => 'application/clariscad', 
			'drw'  => 'application/drafting', 
			'dxf'  => 'application/dxf', 
			'xls'  => 'application/excel', 
			'hdf'  => 'application/hdf', 
			'unv'  => 'application/i-deas', 
			'igs'  => 'application/iges', 
			'iges' => 'application/iges', 
			'doc'  => 'application/msword', 
			'dot'  => 'application/msword', 
			'wrd'  => 'application/msword', 
			'oda'  => 'application/oda', 
			'pdf'  => 'application/pdf', 
			'ppt'  => 'application/powerpoint', 
			'ai'   => 'application/postscript', 
			'eps'  => 'application/postscript', 
			'ps'   => 'application/postscript', 
			'rtf'  => 'application/rtf', 
			'rm'   => 'application/vnd.rn-realmedia', 
			'dvi'  => 'application/x-dvi', 			
			'gtar' => 'application/x-gtar', 
			'tgz'  => 'application/x-gtar', 
			'swf'  => 'application/x-shockwave-flash', 
			'tar'  => 'application/x-tar', 
			'gz'   => 'application/x-gzip-compressed', 
			'zip'  => 'application/x-zip-compressed', 

			'au'   => 'audio/basic', 
			'snd'  => 'audio/basic', 
			'aif'  => 'audio/x-aiff', 
			'aiff' => 'audio/x-aiff', 
			'aifc' => 'audio/x-aiff', 			
			'wma'  => 'audio/x-ms-wma', 

			'mpeg' => 'video/mpeg', 
			'mpg'  => 'video/mpeg', 
			'mpe'  => 'video/mpeg', 
			'mov'  => 'video/quicktime', 
			'avi'  => 'video/msvideo', 
			'movie'=> 'video/x-sgi-movie', 

		  //'unknow' => 'application/octet-stream', 
			'unknow' => 'application/x-unknown-content-type' 
		);
	
	// Format de l'email
	// 1 pour format texte brut
	// 2 pour format html
	// 3 pour fomat alternatif (format html, mais format texte affich si le gestionnaire de courriel du 
	//   destinataire ne supporte pas le format html). // non implment dans cette version
	var $format = 1; 
	
	var $from_online;	
	var $name;
	var $from;
	var $to = array(
			'to' => array(), 
			'cc' => array(), 
			'bcc' => array()
		); 
	var $subject;
	var $message;	
	var $attachfile = array();
	var $boundary_attach;
	var $headers = array();
	
	// Jeu de caractre
	var $charset = "iso-8859-1";
	// Encodage de l'email
	// 7bit, 8bit, quoted-printable, base64, binary
	var $encoding = "8bit"; 
	
	var $server;
	var $smtp_bits;
	var $smtp_reponse; // Variable contenant le message d'erreur SMTP en cas d'erreur de l'envoi.
	var $mail_reponse; // Variable contenant le message d'erreur en cas d'chec de l'envoi.
	
	var $debug = false;	
	
	var $statut = true;
	
	/*
	 * Mailer : Mailer()
	 * 
	 * @param string $dir : Chemin vers les modles d'email
	 * 
	 * @return void
	 */
	function Mailer( $dir = '')
	{
		if( $dir != '' )
		{
			$this->set_root($dir);
		}
	}
	
	/*
	 * Mailer : set_root()
	 * 
	 * @param string $dir : Nom de dossier
	 * 
	 * @return boolean
	 */
	function set_root($dir)
	{
		if( !is_dir($dir) )
		{
			$this->error("set_root()","Le chemin \"<b>$dir</b>\" est incorrect.");
			return false;
		}

		$this->root = $dir;
		return true;
	}
	
	/*
	 * Mailer : set_file()
	 * 
	 * @param string $dir 	: Chemin vers le fichier
	 * @param string $file 	: Nom du fichier
	 * 
	 * @return boolean
	 */
	function set_file($dir, $file)
	{
		$path = ( ( substr($dir, -1, 1) != '/' ) ? $dir . '/' : $dir ) . $file;
		
		if( !file_exists($path) )
		{
			$this->error("set_file()","Le fichier \"<b>$file</b>\" est introuvable");
			return false;
		}
		else if( !is_readable($path) )
		{
			$this->error("set_file()","Le fichier \"<b>$file</b>\" n'est pas accessible en lecture");
			return false;
		}
		
		return true;
	}
	
	/*
	 * Mailer : set_smtp()
	 * 
	 * @param string $host 	: Nom du serveur SMTP
	 * @param integer $port : Port de connexion ( 25 dans la grande majorit des cas )
	 * @param string $user 	: Login d'authentification ( si AUTH est support par le serveur )
	 * @param string $pass 	: Password d'authentification
	 * 
	 * @return void
	 */
	function set_smtp($host, $port = '', $user = '', $pass = '' )
	{
		$this->smtp_mode = true;
		$this->smtp['host'] = $host;
		$this->smtp['port'] = ( $port != '' ) ? $port : $this->smtp['port'];
		$this->smtp['user'] = ( $user != '' ) ? $user : $this->smtp['user'];
		$this->smtp['pass'] = ( $pass != '' ) ? $pass : $this->smtp['pass'];
	}
	
	/*
	 * Mailer : loadfile()
	 * 
	 * @param string $dir 	: Chemin vers le fichier
	 * @param string $file 	: Nom du fichier
	 * 
	 * @return string
	 */
	function loadfile( $dir, $file)
	{
		$path = ( ( substr($dir, -1, 1) != '/' ) ? $dir . '/' : $dir ) . $file;

		$fp = @fopen($path, "r");
		if( !$fp )
		{
			$this->error('loadfile()', "Lecture du fichier \"<b>$file</b>\" impossible");
			return false;
		}

		$content = fread($fp, filesize($path) );
		fclose($fp);

		return $content;
	}
	
	/*
	 * Mailer : set_format()
	 * 
	 * @param string ou integer $format : Format de l'email
	 * 
	 * @return void
	 */
	function set_format($format)
	{
		$format = strtolower($format);
		
		switch($format)
		{
			case "html":
			case "htm":
			case 2:
				$this->format = 2;
				break;
			
			case "texte":
			case "txt":
			case "text":
			case 1:
			default:
				$this->format = 1;
				break;
		}
	}
	
	/*
	 * Mailer : set_from()
	 * 
	 * @param string $email_from 	: Email de l'expditeur
	 * @param string $name_from 	: Personnalisation du nom de l'expditeur
	 * 
	 * @return void
	 */
	function set_from($email_from, $name_from = '')
	{
		$this->from = trim($email_from);
		$this->name = trim($name_from);
		
		if( $this->hebergeur == 2 )
		{
			ereg('^([-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+)'.'@'.
				 '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
				 '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $this->from, $reg);
			$this->from_online = $reg[1];
						
			$this->headers['From'] = $reg[1];
			$this->headers['Reply-To'] = $reg[1];
			$this->headers['Return-Path'] = $reg[1];
			$this->headers['X-Sender'] = "<" . $reg[1] . ">";
		}
		else
		{			
			$this->name = ( $this->name != '' ) ? $this->name : $this->from;
			$this->headers['From'] = "\"" . $this->name . "\"<" . $this->from . ">";
			$this->headers['Reply-To'] = $this->from;
			$this->headers['Return-Path'] = $this->from;
			$this->headers['X-Sender'] = "<" . $this->from . ">";
		}
	}
	
	/*
	 * Mailer : set_to()
	 * 
	 * @param array $to 	: Tableau contenant la liste des destinataires
	 * @param string $type 	: Type d'envoi aux destinataires(cc ou bcc)
	 * 
	 * @return void
	 */
	function set_to($to, $type = '')
	{
		if( !is_array($to) )
		{
			$this->error('set_to()', "Argument incorrect, set_to() doit recevoir un tableau.");
		}
		
		if( strtolower($type) == 'cc' )
		{
			for( $i = 0; $i < count($to); $i++ )
			{
				$this->to['cc'][] = trim($to[$i]);
			}
		}
		else if( strtolower($type) == 'bcc' )
		{
			for( $i = 0; $i < count($to); $i++ )
			{
				$this->to['bcc'][] = trim($to[$i]);
			}
		}
		else
		{
			for( $i = 0; $i < count($to); $i++ )
			{
				$this->to['to'][] = trim($to[$i]);
			}
		}
	}
	
	/*
	 * Mailer : set_subject()
	 * 
	 * @param string $subject : Le sujet de l'email
	 * 
	 * @return void
	 */
	function set_subject($subject)
	{
		$this->subject = trim($subject);
	}
	
	/*
	 * Mailer : set_message()
	 * 
	 * @param string $var 		: contient soit le message, soit le nom du modle d'email  lire
	 * @param array $vararray 	: Tableau contenant les variables  remplacer dans le modle
	 * 
	 * @return void
	 */
	function set_message($var, $vararray = '')
	{
		if( is_array($vararray) )
		{
			$this->set_root($this->root);
			$message = $this->loadfile($this->root, $var);
			
			reset($vararray);
			while( list($key, $val) = each($vararray) )
			{
				$key = '%'.$key.'%';
				$message = str_replace($key, $val, $message);
			}
			
			$this->message = trim($message);
		}
		else if($vararray == '')
		{
			$this->message = trim($var);
		}
	}
	
	/*
	 * Mailer : attachment()
	 * 
	 * @param array $filearray : Tableau contenant le chemin d'accs au fichier  metre en pices jointes
	 * 							 et son nom.
	 * 
	 * @return void
	 */
	function attachment($filearray)
	{
		if( !is_array($filearray) )
		{
			$this->error('attachment()', "Argument incorrect, attachment() doit recevoir un tableau.");
		}
		
		reset($filearray);
		while( list( $file, $dir) = each($filearray) )
		{
			$this->set_file( $dir, $file);
			$this->attachfile[$file] = $dir;
		}
	}
	
	/*
	 * Mailer : set_notify()
	 * 
	 * @return void
	 */
	function set_notify()
	{
		$this->headers['Disposition-Notification-To'] = "\"" . $this->name . "\" <" . $this->from . ">";
	}
	
	function organization($soc)
	{
		$this->headers['Organization'] = $soc;
	}
	
	/*
	 * Mailer : set_priority()
	 * 
	 * @param string ou integer $level : Niveau de priorit de l'email
	 * 
	 * @return void
	 */
	function set_priority($level)
	{
		$level = strtolower($level);
		
		switch($level)
		{
			case 1:
			case "highest":
				$this->headers['X-Priority'] = "1";
				$this->headers['X-MSMail-Priority'] = "Highest";
				break;
			
			case 2:
			case "hight":
				$this->headers['X-Priority'] = "2";
				$this->headers['X-MSMail-Priority'] = "High";
				break;
			
			case 4:
			case "low":
				$this->headers['X-Priority'] = "4";
				$this->headers['X-MSMail-Priority'] = "Low";
				break;
			
			case 5:
			case "lowest":
				$this->headers['X-Priority'] = "5";
				$this->headers['X-MSMail-Priority'] = "Lowest";
				break;
			
			case 3:
			case "normal":
			default:
				$this->headers['X-Priority'] = "3";
				$this->headers['X-MSMail-Priority'] = "Normal";
				break;
		}
	}
	
	/*
	 * Mailer : send()
	 * 
	 * @return boolean
	 */
	function send()
	{
		$this->build_headers();
		$this->build_message();
		
		if( count($this->to['to']) == 0 )
		{
			$this->error('send()', "Aucun destinataire principal n'a t dfini'");
		}
			
		$to_list = implode(", ", $this->to['to']);
		
		if( !$this->statut )
		{
			return false;
		}		
		else if( $this->smtp_mode )
		{
			$result = $this->mailsmtp($this->to['to'], $this->subject, $this->message, $this->headers);
		}
		else if( $this->hebergeur == 1 )
		{
			$result = @mail($to_list, $this->subject, $this->message, $this->headers);
		}
		else if( $this->hebergeur == 2 )
		{
			$result = @email($this->from_online, $to_list, $this->subject, $this->message, $this->headers);
		}
		else if( $this->hebergeur == 3 )
		{
			include("mail.inc");
			$result = @email($to_list, $this->subject, $this->message, $this->headers);
		}
		else
		{
			$this->error('send()', "Aucune fonction d'envoi n'est dfinie.");
			$result = false;
		}
		
		return $result;
	}
	
	/*
	 * Mailer : build_headers()
	 * 
	 * @return void
	 */
	function build_headers()
	{
		global $HTTP_SERVER_VARS, $HTTP_ENV_VARS;
		
		if( count($this->to['to']) == 0 )
		{
			$this->to['to'][] = $this->from;
		}
		
		if( $this->smtp_mode )
		{
			$this->headers['Subject'] = $this->subject;
			
			$to_list = implode(", ", $this->to['to']);
			$this->headers['To'] = $to_list;
		}
		
		if( count($this->to['cc']) > 0 )
		{
			if( $this->smtp_mode )
			{
				for( $i = 0; $i < count($this->to['cc']); $i++ )
				{
					$this->to['to'][] = $this->to['cc'][$i];
					//$this->headers['Cc'] .= ( $i == 0 ) ? '' : ', ';
					//$this->headers['Cc'] .= "<" . $to['cc'][$i] . ">";
				}
			}
			else
			{
				$cc_list = '';
				for( $i = 0; $i < count($this->to['cc']); $i++ )
				{
					$cc_list .= ( $i == 0 ) ? '' : ', ';
					$cc_list .= "<" . $this->to['cc'][$i] . ">";
				}

				$this->headers['Cc'] = $cc_list;
			}
		}
		
		if( count($this->to['bcc']) > 0 )
		{
			if( $this->smtp_mode )
			{
				for( $i = 0; $i < count($this->to['bcc']); $i++ )
				{
					$this->to['to'][] = $this->to['bcc'][$i];
					//$this->headers['Bcc'] .= ( $i == 0 ) ? '' : ', ';
					//$this->headers['Bcc'] .= "<" . $to['bcc'][$i] . ">";
				}
			}
			else
			{
				$bcc_list = '';
				for( $i = 0; $i < count($this->to['bcc']); $i++ )
				{
					$bcc_list .= ( $i == 0 ) ? '' : ', ';
					$bcc_list .= "<" . $this->to['bcc'][$i] . ">";
				}
		
				$this->headers['Bcc'] = $bcc_list;
			}			
		}
		
		$this->headers['Date'] = date('D, d M Y H:i:s O', time());
		$this->headers['X-Mailer'] = "WAmailer/1.3 PHP/" . phpversion();
		
		if( !empty($HTTP_SERVER_VARS['SERVER_NAME']) OR !empty($HTTP_ENV_VARS['SERVER_NAME']) )
		{
			$server = ( !empty($HTTP_SERVER_VARS['SERVER_NAME']) ) ? $HTTP_SERVER_VARS['SERVER_NAME'] : $HTTP_ENV_VARS['SERVER_NAME'];
		}
		else if( !empty($HTTP_SERVER_VARS['HTTP_HOST']) OR !empty($HTTP_ENV_VARS['HTTP_HOST']) )
		{
			$server = ( !empty($HTTP_SERVER_VARS['HTTP_HOST']) ) ? $HTTP_SERVER_VARS['HTTP_HOST'] : $HTTP_ENV_VARS['HTTP_HOST'];
		}
		else
		{
			$server = '';
		}
		
		$this->server = ( $server != '' ) ? $server : 'localhost';
		
		$sender_ip = ( !empty($HTTP_SERVER_VARS['REMOTE_ADDR']) ) ? $HTTP_SERVER_VARS['REMOTE_ADDR'] : ( ( !empty($HTTP_ENV_VARS['REMOTE_ADDR']) ) ? $HTTP_ENV_VARS['REMOTE_ADDR'] : '' );

		if( $sender_ip AND $server )
		{
			$this->headers['X-AntiAbuse'] = "Sender IP - $sender_ip Server Name - <$server>";
		}
		
		if( count($this->attachfile) > 0 )
		{
			$this->boundary_attach = "-----=" . md5( uniqid ( rand() ) );
			$this->headers['MIME-Version'] = "1.0";
			$this->headers['Content-Type'] = "multipart/mixed; boundary=\"" . $this->boundary_attach . "\"";
		}
		else
		{
			$this->headers['Content-Type'] = ( $this->format == 2 ) ? "text/html; charset=\"" . $this->charset . "\"" : "text/plain; charset=" . $this->charset;
			$this->headers['Content-Transfer-Encoding'] = $this->encoding;
		}
		
		$headers = '';
		$i = 0;
		$total_headers = count($this->headers);
		while( list($title_header, $content_header) = each($this->headers) )
		{
			$headers .= $title_header . ": " . $content_header;
			$headers .= ( ($i + 1) < $total_headers ) ? "\n" : "";
			$i++;
		}
		
		$this->headers = $headers;
	}
	
	/*
	 * Mailer : build_message()
	 * 
	 * @return void
	 */
	function build_message()
	{
		if( count($this->attachfile) > 0 )
		{
			$message = "Ceci est un message au format MIME 1.0 multipart/mixed. ( fichier attach )\n";			
			$message .= "--" . $this->boundary_attach . "\n";
			$message .= ( $this->format == 2 ) ? "Content-Type: text/html; charset=\"" . $this->charset . "\"\n" : "Content-Type: text/plain; charset=" . $this->charset . "\n";
			$message .= "Content-Transfer-Encoding: " . $this->encoding . "\n\n";
			$message .= $this->message;
			$message .= "\n\n";
			
			while( list( $file, $dir) = each($this->attachfile) )
			{
				$attach_file = chunk_split( base64_encode( $this->loadfile($dir, $file) ) );
				$part = pathinfo($dir . $file);
				$part["extension"] = strtolower($part["extension"]);
				
				$filetype = $this->mime_type[$part["extension"]];
				if( $filetype == '' )
				{
					$filetype = $this->mime_type["unknow"];
				}
				
				$message .= "--" . $this->boundary_attach . "\n";				
				$message .= "Content-Type: $filetype; name=\"$file\"\n";
				$message .= "Content-Transfer-Encoding: base64\n";
				$message .= "Content-Disposition: attachment; filename=\"$file\"\n\n";
				$message .= $attach_file . "\n";
				$message .= "\n\n";

			}
			
			$message .= "--" . $this->boundary_attach . "--\n";
			
			$this->message = $message;
		}
	}
	
	/*
	 * Mailer : mailsmtp()
	 *
	 * Description : Envoi d'emails via connexion au serveur smtp dfini.
	 * 
	 * @param array $to			: tableau contenant la liste des adresses directe (to), la liste des 
	 * 							  copie (cc) et la liste des copies caches (bcc)
	 * @param string $subject 	: Le sujet de l'email
	 * @param string $message 	: Le message construit (fichier attach ou pas, etc...)
	 * @param array $headers 	: Le tableau contenant les entetes
	 * 
	 * @return boolean
	 *
	 * Les sources qui m'ont bien aides : 
	 * 
	 * @link : http://www.rfc-editor.org/
	 * @link : http://strasbourg.ort.asso.fr/examen2000/np.html#SMTP
	 * @link : http://www.commentcamarche.net/internet/smtp.php3
	 * @link : http://abcdrfc.free.fr/
	 * @link : http://www.interpc.fr/mapage/billaud/telmail.htm
	 *
	 * Toutes les commandes de connexion et de dialogue avec le serveur sont 
	 * dtailles dans la RFC 821.
	 * 
	 * Les commandes d'authentification au serveur sont dtailles dans 
	 * la RFC 2554 ( note: Impossible de trouver cette fichu RFC 2554 en franais ou 
	 * de trouver des infos satisfaisantes sur la commande AUTH ).
	 * 
	 * @link : http://www.rfc-editor.org/rfc/rfc2554.txt
	 * 
	 */	
	function mailsmtp($to, $subject, $message, $headers)
	{
		$authentification = ( !empty($this->smtp['user']) AND !empty($this->smtp['pass']) ) ? true : false;
				
		// Ouverture de la connexion au serveur SMTP
		$socket = fsockopen($this->smtp['host'], $this->smtp['port'], &$errno, &$errstr);
		if( !$socket )
		{
			$this->error('mailsmtp()', "Echec lors de la connexion au serveur smtp : $errno $errstr");
		}
		
		// 
		// Code success : 220
		// Code failure : 421
		//		
		$result = $this->parse_reponse($socket, "220", __LINE__);
		if( !$result ) return false;
		
		//
		// Comme on est poli, on dit bonjour.
		// Selon que le serveur supporte les messages 8bits ou pas, EHLO ou HELO
		// mais ce n'est apparamment pas primordial.
		//
		// Code success	: 250
        // Code error	: 500, 501, 504, 421
		//
		$welcome = ( $this->smtp_bits == '8' ) ? "EHLO " . $this->server : "HELO " . $this->server;
		
		fputs($socket, $welcome . "\r\n"); 
		$result = $this->parse_reponse($socket, "250", __LINE__);
		if( !$result ) return false;
		
		if( $authentification )
		{
			fputs($socket, "AUTH LOGIN\r\n");
			$result = $this->parse_reponse($socket, "334", __LINE__);
			if( !$result ) return false;
			
			fputs($socket, base64_encode($this->smtp['user']) . "\r\n");
			$result = $this->parse_reponse($socket, "334", __LINE__);
			if( !$result ) return false;
			
			fputs($socket, base64_encode($this->smtp['pass']) . "\r\n");
			$result = $this->parse_reponse($socket, "235", __LINE__);
			if( !$result ) return false;
		}
		
		//
		// On spcifie l'adresse de l'expditeur
		//
		// Code success	: 250
        // Code failure	: 552,451,452
        // Code error	: 500,501,421
		//
		fputs($socket, "MAIL FROM: <" . $this->from . ">\r\n");
		$result = $this->parse_reponse($socket, "250", __LINE__);
		if( !$result ) return false;
		
		//
		// On spcifie les destinatires au serveur smtp
		//
		// Code success	: 250,251
        // Code failure	: 550,551,552,553,450,451,452
        // Code error	: 500,501,503,421
		//
		while( list( $key, $email_to) = each($to) )
		{
			fputs($socket, "RCPT TO: <" . $email_to . ">\r\n"); 
			$result = $this->parse_reponse($socket, "250", __LINE__);
			if( !$result ) return false;
		}
		
		//
		// On indique au serveur que l'on va lui livrer les donnes
		//
		// Code success	: 354
		//
		fputs($socket, "DATA\r\n");
		$result = $this->parse_reponse($socket, "354", __LINE__);
		if( !$result ) return false;
		
		// On envoie les enttes
		fputs($socket, "$headers\r\n\r\n");

		// Et maintenant le message
		fputs($socket, "$message\r\n");

		//
		// On indique la fin de l'envoi de donnes au serveur
		//
		// Code success	: 250
        // Code failure	: 552,554,451,452
        // Code error	: 500,501,503,421
		//
		fputs($socket, ".\r\n");
		$result = $this->parse_reponse($socket, "250", __LINE__);
		if( !$result ) return false;

		// Comme on est poli, on dit aurevoir au serveur avec la commande adquat QUIT
		fputs($socket, "QUIT\r\n");
		fclose($socket);
		
		return true;
	}

	/*
	 * Mailer : parse_reponse()
	 * 
	 * @param resource $socket 	: Identifiant de connexion avec le serveur SMTP
	 * @param integer $code 	: Le code qui doit tre obtenu pour continuer
	 * @param integer $line		: La ligne o s'est produite l'erreur (pour mieux s'y retrouver)
	 * 
	 * @return boolean
	 */
	function parse_reponse($socket, $code, $line)
	{
		while( substr($reponse, 3, 1) != ' ' )
		{
			$reponse = fgets($socket, 500);
		}
		
		if( $code == "220" )
		{
			$this->smtp_bits = ( ereg("ESMTP", $reponse) ) ? 8 : 7;
		}
		
		$this->smtp_reponse = '<br /><br />mailsmtp() <b>Erreur smtp</b> : ' . $reponse . ' -- Ligne : ' . $line;
						
		if( !( substr($reponse, 0, 3) == $code) )
		{
			$this->error('send()', "Un problme est survenu durant l'envoi via smtp :<br /><br /> " . nl2br( htmlentities($reponse) ) . " <br />Ligne : $line");
			return false;
		}
		
		return true;
	}
	
	/*
	 * Mailer : init()
	 * 
	 * @return void
	 */
	function init()
	{
		$this->from_online = '';
		$this->name = '';
		$this->from = '';
		$this->to['to'] = array();
		$this->to['cc'] = array();
		$this->to['bcc'] = array();
		$this->subject = '';
		$this->message = '';
		$this->attachfile = array();
		$this->boundary_attach = '';
		$this->headers = array();
		
		$this->smtp_reponse = ''; 		
		$this->mail_reponse = '';
	}

	/*
	 * Mailer : error()
	 * 
	 * @param string $fct 	: La dernire fonction o s'est produite l'erreur
	 * @param string $error : Le message d'erreur  afficher si mode debug
	 * 
	 * @return void
	 */
	function error( $fct, $error)
	{
		$this->mail_reponse = sprintf("<br /><br />%s <b>Erreur</b> : %s", $fct, $error); 
		
		$this->statut = false;
		
		if( $this->debug )
		{
			echo $this->mail_reponse;
			exit;
		}
	}
	
}// fin de classe
?>